/* Some of you may choose to define TYPE as a "float" instead... */
#define TYPE            double          /* Type of numbers to work with */

#define VARLEN          15              /* Max length of variable names */
#define MAXVARS         50              /* Max user-defined variables */
#define TOKLEN          30              /* Max token length */

#define VAR             1
#define DEL             2
#define NUM             3


typedef struct
{
   char name[VARLEN + 1];               /* Variable name */
   TYPE value;                          /* Variable value */
} VARIABLE;

//	April 1995	RMD-	made C++ compatible
typedef float (*FunctionPtr)(float, float, float);

typedef struct
{
   char*		name;					/* Function name */
   short		args;					/* Number of arguments to expect */
   FunctionPtr  func;					 /* Pointer to function */
//   TYPE  (*func)();                     /* Pointer to function */
} FUNCTION;

/* The following macros are ASCII dependant, no EBCDIC here! */
#define iswhite(c)  (c == ' ' || c == '\t')
#define isnumer(c)  ((c >= '0' && c <= '9') || c == '.')
#define isalpha(c)  ((c >= 'a' && c <= 'z') || (c >= '0' && c <= '9') \
                    || c == '_')
#define isdelim(c)  (c == '+' || c == '-' || c == '*' || c == '/' || c == '%' \
                    || c == '^' || c == '(' || c == ')' || c == ',' || c == '=')

/* Codes returned from the evaluator */
#define E_OK           0        /* Successful evaluation */
#define E_SYNTAX       1        /* Syntax error */
#define E_UNBALAN      2        /* Unbalanced parenthesis */
#define E_DIVZERO      3        /* Attempted division by zero */
#define E_UNKNOWN      4        /* Reference to unknown variable */
#define E_MAXVARS      5        /* Maximum variables exceeded */
#define E_BADFUNC      6        /* Unrecognised function */
#define E_NUMARGS      7        /* Wrong number of arguments to funtion */
#define E_NOARG        8        /* Missing an argument to a funtion */
#define E_EMPTY        9        /* Empty expression */


//	April 1995	RMD-	Add ANSI prototypes

double	deg( double x );
double	rad( double x );
short	GetSymbol( char* s, TYPE* v );
void	ClearAllVars(void);
Boolean ClearVar( char* name );
Boolean GetValue( char* name, TYPE* value );
Boolean SetValue( char* name, TYPE* value );

static Boolean	Level1( TYPE* r );
static void		Level2( TYPE* r );
static void		Level3( TYPE* r );
static void		Level4( TYPE* r );
static void		Level5( TYPE* r );
static void		Level6( TYPE* r );

Boolean Evaluate( char* e, TYPE* result, short* a );